Attribute VB_Name = "DirOpen"
'========================================================
'=      MacrosHunter =
'=      2002    =
'=     MS Word 97               =
'========================================================
'      
'   
Option Explicit
Private Type BrowseInfo '  
  hWndOwner As Long
  pIDLRoot As Long
  pszDisplayName As Long
  lpszTitle As Long
  ulFlags As Long
  lpfnCallback As Long
  lParam As Long
  iImage As Long
End Type

'  
'Private Const BIF_RETURNONLYFSDIRS = &H1 '   ,    
'Private Const BIF_DONTGOBELOWDOMAIN = &H2 '    Find
'Private Const BIF_STATUSTEXT = &H4
'Private Const BIF_RETURNFSANCESTORS = &H8

'Private Const BIF_BROWSEFORCOMPUTER = &H1000 '  
'Private Const BIF_BROWSEFORPRINTER = &H2000 '  
'Private Const BIF_BROWSEINCLUDEFILES = &H4000 '  

Private Const MAX_PATH = 260

Private Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal hMem As Long)
Private Declare Function lstrcat Lib "kernel32" Alias "lstrcatA" (ByVal lpString1 As String, ByVal lpString2 As String) As Long
Private Declare Function SHBrowseForFolder Lib "shell32" (lpbi As BrowseInfo) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long

Public Function BrowseForFolder(sPrompt As String) As String
 '============================================================
 '       
 ' :
 ' BrowseForFolder <> "" -  
 '   !        !
 '============================================================
 Dim iNull As Integer
 Dim lpIDList As Long
 Dim sPath As String
 Dim udtBI As BrowseInfo
 
 '   
 With udtBI
   ' .hWndOwner = hWndOwner
    .lpszTitle = lstrcat(sPrompt, "")
    .ulFlags = 1 '   
 End With

 lpIDList = SHBrowseForFolder(udtBI)
 If lpIDList Then '  
    sPath = String$(MAX_PATH, 0)
    Call SHGetPathFromIDList(lpIDList, sPath)
    Call CoTaskMemFree(lpIDList)
    iNull = InStr(sPath, vbNullChar)
    If iNull Then '   
        sPath = Left$(sPath, iNull - 1)
        '  "\"    
        If Right(sPath, 1) = "\" Then _
          sPath = Left(sPath, Len(sPath) - 1)
    End If
 End If
 BrowseForFolder = sPath
End Function